CC = gcc
CXX = g++

CXXFLAGS = -Wall -Wextra -I/usr/local/include/vmime/
CXXFLAGS += -ffunction-sections -fdata-sections
CXXFLAGS += -O2

#--
LIB_RWIDGETS = ../applets/widgets/librwidgets.a
LIB_RPOP3    = ../network/librpop3.a

CFLAGS  = -Wall -Wextra -Wstrict-prototypes -pedantic
CFLAGS += -ffunction-sections -fdata-sections
#CFLAGS += -g -ggdb
CFLAGS += -O2
CFLAGS += -I. -I../md5 -I../network -I../applets/osd -I../applets/widgets
CFLAGS += -I/usr/X11R6/include -I/usr/include
#CFLAGS += -DPIXMAP_PATH=\"$(PIXMAP_PATH)\" -DPIXMAP_DEFAULT=\"$(PIXMAP_PATH)mail.png\"

LDFLAGS  = -Wl,--gc-sections
LDFLAGS += -Wl,--as-needed

LIBRARIES =

TARGETS = \
	test_vmime \
	test_list \
	test_list_x11 \
	test_header_osd \
	test_view_mail \
	test_pop3_list \

COMMON_OBJS = \
	string_utils.o \
	file_utils.o \
	rfc5322.o \
	rfc2047.o \
	rfc822.o \
	mail.o \
	mime.o

MD5_OBJS = ../md5/md5.o
MD5_UTILS_OBJS = ../md5/md5_utils.o

OSD_OBJS = \
	../applets/osd/osd.o     \
	../applets/widgets/png.o \
	icons_utils.o

WIDGETS_OBJS = \
	../applets/widgets/png.o


#-- target specific flags
test_list_x11:   LIBRARIES += $(LIB_RWIDGETS) -L/usr/X11R6/lib -lXaw -lXt -lX11 -lpng
test_header_osd: LIBRARIES += -lXft -lpng
test_pop3_list:  LIBRARIES += $(LIB_RPOP3) -L/usr/local/lib -lpolarssl

test_vmime: LIBRARIES += $(LIB_RPOP3) -L/usr/local/lib -lpolarssl
test_vmime: LIBRARIES += -L/usr/local/lib -lvmime

#--
%.o:%.c
	@echo "  CC    $<"
	$(CC) $(CFLAGS) -c $< -o $@

.PHONY: $(TARGETS) clean all

.SILENT:

all: $(TARGETS)

test_header_osd: test_header_osd.o $(COMMON_OBJS) $(MD5_OBJS) $(MD5_UTILS_OBJS) $(OSD_OBJS)
	@echo "  LD    $@"
	$(CC) $(LDFLAGS) $^ $(LIBRARIES) -o $@

test_list: test_list.o list.o $(COMMON_OBJS) $(MD5_OBJS) $(MD5_UTILS_OBJS)
	@echo "  LD    $@"
	$(CC) $(LDFLAGS) $^ $(LIBRARIES) -o $@

test_list_x11: test_list_x11.o list.o icons_utils.o $(WIDGETS_OBJS) $(COMMON_OBJS) $(MD5_OBJS) $(MD5_UTILS_OBJS)
	@echo "  LD    $@"
	$(CC) $(LDFLAGS) $^ $(LIBRARIES) -o $@

test_pop3_list: test_pop3_list.o list.o $(COMMON_OBJS) $(MD5_UTILS_OBJS)
	@echo "  LD    $@"
	$(CC) $(LDFLAGS) $^ $(LIBRARIES) -o $@

test_view_mail: test_view_mail.o $(COMMON_OBJS) $(MD5_OBJS) $(MD5_UTILS_OBJS)
	@echo "  LD    $@"
	$(CC) $(LDFLAGS) $^ $(LIBRARIES) -o $@

test_vmime: test_vmime.cpp
	@echo "  CXX+LD $@"
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $^ $(LIBRARIES) -o $@

clean:
	rm -f $(TARGETS) *.o *~

